#include <iostream>
using namespace std;

class CustomExceptionParent
{
    public:
        int x = 1;
        virtual void func() const // what if we skip the virtual keyword?
        {
            cout << "Parent exception" << endl;
        }
};

class CustomExceptionChild: public CustomExceptionParent
{
    public:
        void func() const
        {
            cout << "Child exception" << endl;
        }
};

int main()
{
    try
    {
        throw CustomExceptionChild();
    }

    // Polymorphic reference - will this catch?
    catch(const CustomExceptionParent &e)
    {
        cerr << "Parent catch: " << e.x << endl;
        e.func();
    }

    // This would catch if it was first
    catch(const CustomExceptionChild &e)
    {
        cerr << "Child catch: " << e.x << endl;
        e.func();
    }

    catch(...)
    {
        cerr <<"Some fatal error" << endl;
    }
}

