#include <iostream>
using namespace std;

class CustomExceptionParent
{
    public:
        int x = 1;
        
        virtual void func() const // what if we skip the virtual keyword?
        {
            cout << "Parent class error:" << endl;
        }
};

class CustomExceptionChild: public CustomExceptionParent
{
    private:
        int flexibleError;

    public:
        CustomExceptionChild(const int &err): flexibleError(err) {}

        void func() const
        {
            cout << "Child class error: " << flexibleError << endl;
        }
};

int main()
{
    try
    {
        throw CustomExceptionChild(5);
    }

    // Polymorphic reference
    catch(const CustomExceptionParent &e)
    {
        cerr << e.x << endl;
        e.func();
    }

    catch(...)
    {
        cerr <<"Some fatal error" << endl;
    }
}

