/**
  bad_alloc example

  Type of the exceptions thrown by the standard definitions
  of operator new and operator new[] when they fail to allocate
  the requested storage space.

  This class is derived from exception. See the exception
  class for the member definitions of standard exceptions.

  Its member what returns a null-terminated character
  sequence identifying the exception.
  */

#include <iostream>     // std::cout
#include <new>          // std::bad_alloc

int main()
{
    try
    {
        long *myReallyReallyReallyBigArray= new long[1000000000000000];
    }
    catch (const std::bad_alloc &ba)
    {
        std::cerr << "bad_alloc caught: " << ba.what() << std::endl << std::endl;
    }

    // what if we make the same error down here?
    long *myReallyReallyReallyBigArray = new long[1000000000000000];

    return 0;
}

