/**
  Type of the exceptions thrown by typeid when
  applied on a pointer to a polymorphic type
  which has a null pointer value.

  Its member what returns a null-terminated character
  sequence identifying the exception.
  */

#include <typeinfo>
#include <iostream>

class Test
{
    public:
        Test();
        virtual ~Test();
};

int main()
{
    Test *ptrvar = NULL;

    try
    {
        std::cout << typeid(*ptrvar).name() << std::endl;
    }

    catch (const std::bad_typeid& errorThing)
    {
        std::cout << "The object is null: " << errorThing.what() << std::endl << std::endl;
    }

    // what if we make the same error down here?
    std::cout << typeid(*ptrvar).name() << std::endl;

    return 0;
}

