// using standard exceptions

#include <iostream>
#include <exception>
using std::cout;
using std::endl;

// look at exception class provided by #include (in slides)
class myexception: public std::exception
{
    public:
        virtual const char * what() const throw() // virtual needed? Effect?
        {
            //cout << "Hi" << endl;
            return "My exception happened";
        }
};

int main()
{
    try
    {
        throw myexception();
    }

    catch(const std::exception &e)
    {
        cout << "Parent catch: " << e.what() << endl;
    }

    catch(const myexception &e)
    {
        cout << "Child catch: " << e.what() << endl;
    }

    // what happens if I throw my custom exception here?
    throw myexception();

    return 0;
}

