/**
  This is a practical way to use exceptions.
  Make any custom of your own inherit exception.
  Don't bother catching anything specific.
  Catch yours first, then all standard by const reference, so you can save/print/etc.
  Then
 **/

// using standard exceptions
#include <iostream>
#include <exception>
using namespace std;

// look at exception class provided by #include (in slides)
class myexception: public exception
{
    public:
        virtual const char * what() const throw() // virtual needed? Effect?
        {
            //cout << "Hi" << endl;
            return "My exception happened";
        }
};

int main()
{
    // No matter the error, it gets caught.
    try
    {
        throw myexception();
    }

    catch(const myexception &e)
    {
        cerr << "Child catch: " << e.what() << endl;
    }

    catch(const exception &e)
    {
        cerr << "Parent catch: " << e.what() << endl;
    }

    catch(...)
    {
        cerr << "Something else happened: " << std::endl;
    }

    // No matter the error, it gets caught.
    try
    {
        long *myReallyReallyReallyBigArray= new long[1000000000000000];
    }

    catch(const myexception &e)
    {
        cout << "Child catch: " << e.what() << endl;
    }

    catch(const exception &e)
    {
        cout << "Parent catch: " << e.what() << endl;
    }

    catch(...)
    {
        std::cerr << "Something else happened: " << std::endl;
    }

    return 0;
}

